#include "src/lauxlib.h"
#include "Ballistics/ballistics.h"

int Lua_DegtoMOA(lua_State* L) {
	if(lua_gettop(L)<1) {
		lua_pushstring(L,"function DegtoMOA expected 1 argument\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function DegtoMOA expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	double n = lua_tonumber(L, 1);
	lua_pushnumber(L,DegtoMOA(n));
	return 1;
}
int Lua_DegtoRad(lua_State* L) {
	if(lua_gettop(L)<1) {
		lua_pushstring(L,"function DegtoRad expected 1 argument\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function DegtoRad expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	double n = lua_tonumber(L, 1);
	lua_pushnumber(L,DegtoRad(n));
	return 1;
}
int Lua_MOAtoDeg(lua_State* L) {
	if(lua_gettop(L)<1) {
		lua_pushstring(L,"function MOAtoDeg expected 1 argument\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function MOAtoDeg expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	double n = lua_tonumber(L, 1);
	lua_pushnumber(L,MOAtoDeg(n));
	return 1;
}
int Lua_MOAtoRad(lua_State* L) {
	if(lua_gettop(L)<1) {
		lua_pushstring(L,"function MOAtoRad expected 1 argument\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function MOAtoRad expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	double n = lua_tonumber(L, 1);
	lua_pushnumber(L,MOAtoRad(n));
	return 1;
}
int Lua_RadtoDeg(lua_State* L) {
	if(lua_gettop(L)<1) {
		lua_pushstring(L,"function RadtoDeg expected 1 argument\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function RadtoDeg expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	double n = lua_tonumber(L, 1);
	lua_pushnumber(L,RadtoDeg(n));
	return 1;
}
int Lua_RadtoMOA(lua_State* L) {
	if(lua_gettop(L)<1) {
		lua_pushstring(L,"function RadtoMOA expected 1 argument\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function RadtoMOA expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	double n = lua_tonumber(L, 1);
	lua_pushnumber(L,RadtoMOA(n));
	return 1;
}

inline int GetDragFunc(char* DF_Str) {
	if(strcmp(DF_Str,"G1")) {
		return 1;
	} else if(strcmp(DF_Str,"G2")) {
		return 2;
	} else if(strcmp(DF_Str,"G3")) {
		return 3;
	} else if(strcmp(DF_Str,"G4")) {
		return 4;
	} else if(strcmp(DF_Str,"G5")) {
		return 5;
	} else if(strcmp(DF_Str,"G6")) {
		return 6;
	} else if(strcmp(DF_Str,"G7")) {
		return 7;
	} else if(strcmp(DF_Str,"G8")) {
		return 8;
	} else {
		return 1;
	}
}

int Lua_retard(lua_State* L) {
	if(lua_gettop(L)<3) {
		lua_pushstring(L,"function retard expected 3 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isstring(L,1)) {
		lua_pushstring(L,"function retard expected argument #1 to be a string\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function retard expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,3)) {
		lua_pushstring(L,"function retard expected argument #3 to be a number\n");
		lua_error(L);
		return 0;
	}
	char* DF_Str = lua_tostring(L,1);
	int DF = GetDragFunc(DF_Str);
	double DC = lua_tonumber(L,2);
	double V = lua_tonumber(L,3);
	lua_pushnumber(L,retard(DF,DC,V));
	return 1;
}

int Lua_AtmCorrect(lua_State* L) {
	if(lua_gettop(L)<5) {
		lua_pushstring(L,"function AtmCorrect expected 5 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function AtmCorrect expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function AtmCorrect expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,3)) {
		lua_pushstring(L,"function AtmCorrect expected argument #3 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,4)) {
		lua_pushstring(L,"function AtmCorrect expected argument #4 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,5)) {
		lua_pushstring(L,"function AtmCorrect expected argument #5 to be a number\n");
		lua_error(L);
		return 0;
	}
	double DC = lua_tonumber(L,1);
	double A = lua_tonumber(L,2);
	double B = lua_tonumber(L,3);
	double T = lua_tonumber(L,4);
	double H = lua_tonumber(L,5);
	lua_pushnumber(L,AtmCorrect(DC,A,B,T,H));
	return 1;
}


int Lua_Windage(lua_State* L) {
	if(lua_gettop(L)<4) {
		lua_pushstring(L,"function Windage expected 4 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function Windage expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function Windage expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,3)) {
		lua_pushstring(L,"function Windage expected argument #3 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,4)) {
		lua_pushstring(L,"function Windage expected argument #4 to be a number\n");
		lua_error(L);
		return 0;
	}
	double WS = lua_tonumber(L,1);
	double V = lua_tonumber(L,2);
	double X = lua_tonumber(L,3);
	double T = lua_tonumber(L,4);
	lua_pushnumber(L,Windage(WS,V,X,T));
	return 1;
}

int Lua_HeadWind(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function HeadWind expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function HeadWind expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function HeadWind expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double WS = lua_tonumber(L,1);
	double WA = lua_tonumber(L,2);
	lua_pushnumber(L,HeadWind(WS,WA));
	return 1;
}
int Lua_CrossWind(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function CrossWind expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,1)) {
		lua_pushstring(L,"function CrossWind expected argument #1 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function CrossWind expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double WS = lua_tonumber(L,1);
	double WA = lua_tonumber(L,2);
	lua_pushnumber(L,CrossWind(WS,WA));
	return 1;
}

int Lua_ZeroAngle(lua_State* L) {
	if(lua_gettop(L)<6) {
		lua_pushstring(L,"function ZeroAngle expected 6 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isstring(L,1)) {
		lua_pushstring(L,"function ZeroAngle expected argument #1 to be a string\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function ZeroAngle expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,3)) {
		lua_pushstring(L,"function ZeroAngle expected argument #3 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,4)) {
		lua_pushstring(L,"function ZeroAngle expected argument #4 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,5)) {
		lua_pushstring(L,"function ZeroAngle expected argument #5 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,6)) {
		lua_pushstring(L,"function ZeroAngle expected argument #6 to be a number\n");
		lua_error(L);
		return 0;
	}
	char* DF_Str = lua_tostring(L,1);
	int DF = GetDragFunc(DF_Str);
	double DC = lua_tonumber(L,2);
	double V = lua_tonumber(L,3);
	double SH = lua_tonumber(L,4);
	double ZR = lua_tonumber(L,5);
	double YI = lua_tonumber(L,6);
	lua_pushnumber(L,ZeroAngle(DF,DC,V,SH,ZR,YI));
	return 1;
}

int Lua_SolveAll(lua_State* L) {
	if(lua_gettop(L)<9) {
		lua_pushstring(L,"function SolveAll expected 9 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isstring(L,1)) {
		lua_pushstring(L,"function SolveAll expected argument #1 to be a string\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function SolveAll expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,3)) {
		lua_pushstring(L,"function SolveAll expected argument #3 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,4)) {
		lua_pushstring(L,"function SolveAll expected argument #4 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,5)) {
		lua_pushstring(L,"function SolveAll expected argument #5 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,6)) {
		lua_pushstring(L,"function SolveAll expected argument #6 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,7)) {
		lua_pushstring(L,"function SolveAll expected argument #7 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,8)) {
		lua_pushstring(L,"function SolveAll expected argument #8 to be a number\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,9)) {
		lua_pushstring(L,"function SolveAll expected argument #9 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	char* DF_Str = lua_tostring(L,1);
	int DF = GetDragFunc(DF_Str);
	double DC = lua_tonumber(L,2);
	double V = lua_tonumber(L,3);
	double SH = lua_tonumber(L,4);
	double SA = lua_tonumber(L,5);
	double ZA = lua_tonumber(L,6);
	double WS = lua_tonumber(L,7);
	double WA = lua_tonumber(L,8);
	double** BO = (double**)lua_touserdata(L,9);
	SolveAll(DF,DC,V,SH,SA,ZA,WS,WA,BO);
	return 0;
}

int Lua_GetRange(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetRange expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetRange expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetRange expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetRange(*BO,Y));
	return 1;
}
int Lua_GetPath(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetPath expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetPath expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetPath expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetPath(*BO,Y));
	return 1;
}
int Lua_GetMOA(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetMOA expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetMOA expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetMOA expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetMOA(*BO,Y));
	return 1;
}

int Lua_GetTime(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetTime expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetTime expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetTime expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetTime(*BO,Y));
	return 1;
}
int Lua_GetWindage(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetWindage expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetWindage expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetWindage expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetWindage(*BO,Y));
	return 1;
}
int Lua_GetWindageMOA(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetWindageMOA expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetWindageMOA expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetWindageMOA expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetWindageMOA(*BO,Y));
	return 1;
}
int Lua_GetVelocity(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetVelocity expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetVelocity expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetVelocity expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetVelocity(*BO,Y));
	return 1;
}
int Lua_GetVx(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetVx expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetVx expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetVx expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetVx(*BO,Y));
	return 1;
}
int Lua_GetVy(lua_State* L) {
	if(lua_gettop(L)<2) {
		lua_pushstring(L,"function GetVy expected 2 arguments\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isuserdata(L,1)) {
		lua_pushstring(L,"function GetVy expected argument #1 to be a userdata\n");
		lua_error(L);
		return 0;
	}
	if(!lua_isnumber(L,2)) {
		lua_pushstring(L,"function GetVy expected argument #2 to be a number\n");
		lua_error(L);
		return 0;
	}
	double** BO = (double**)lua_touserdata(L,1);
	int Y = lua_tointeger(L,2);
	lua_pushnumber(L,GetVy(*BO,Y));
	return 1;
}

int Lua_NewBallisticsObj(lua_State* L) {
	double** p = (double**)lua_newuserdata(L, sizeof(double*));
	luaL_getmetatable(L, "BallisticsObj");
	lua_setmetatable(L, -2);
	return 1;
}

int LUA_API luaopen_libBallistics(lua_State* L) {
	static const luaL_reg Ballistics[] = {
		{"DegtoMOA", Lua_DegtoMOA},
		{"DegtoRad", Lua_DegtoRad},
		{"MOAtoDeg", Lua_DegtoRad},
		{"MOAtoRad",Lua_MOAtoRad},
		{"retard",Lua_retard},
		{"AtmCorrect",Lua_AtmCorrect},
		{"Windage",Lua_Windage},
		{"HeadWind",Lua_HeadWind},
		{"CrossWind",Lua_CrossWind},
		{"ZeroAngle",Lua_ZeroAngle},
		{"SolveAll",Lua_SolveAll},
		{"GetRange",Lua_GetRange},
		{"GetPath",Lua_GetPath},
		{"GetMOA",Lua_GetMOA},
		{"GetTime",Lua_GetTime},
		{"GetWindage",Lua_GetWindage},
		{"GetWindageMOA",Lua_GetWindageMOA},
		{"GetVelocity",Lua_GetVelocity},
		{"GetVx",Lua_GetVx},
		{"GetVy",Lua_GetVy},
		{"NewBallisticsObj",Lua_NewBallisticsObj},
		{NULL, NULL}
	};
	luaL_register(L, "Ballistics", Ballistics);
	return 0;
}

